#!/usr/bin/perl
# Text::Kakasiがいります。

use Text::Kakasi;
use Jcode;
print "Step1...\n";
open(W,">all.1");
open(R,"all.txt");
foreach(<R>) {
	s/\x0D\x0A|\x0D|\x0A/\x0A/g;
	$buf=Jcode->new($_)->utf8;
	$buf=~s/ケ/ヶ/g;
	$buf=~s/の/ノ/g;
	print W $buf;
}
close(R);
open(R,"touhoku.all");
foreach(<R>) {
	s/\x0D\x0A|\x0D|\x0A/\x0A/g;
	$buf=Jcode->new($_)->utf8;
	$buf=~s/ケ/ヶ/g;
	$buf=~s/の/ノ/g;
	print W $buf;
}
close(R);
close(W);
print "Step2...\n";
open(W,">all.2");
open(R,"all.1");
foreach $line(<R>) {
	$line=~s/\n//g;
	my ($area1,$area2,$area3,$num,$subgrp)=split(/\t/,$line);
	next if($area1 eq '');
	&init_kakasi;
	$areaen1=&convert($area1);
	$areaen2=&convert($area2);
	$areaen3=&convert($area3);
	&close_kakasi;
	&init_kakasi_kana;
	$areakana1=&kana($area1);
	$areakana2=&kana($area2);
	$areakana3=&kana($area3);
	&close_kakasi;
#	$group=$subgrp eq '' ? $num : "$num-$subgrp";
#	print W "$area1\t$area2\t$area3\t$group\t$areaen1\t$areaen2\t$areaen3\t$areakana1\t$areakana2\t$areakana3\n";
	print W "$area1\t$area2\t$area3\t$num\t$subgrp\t$areaen1\t$areaen2\t$areaen3\t$areakana1\t$areakana2\t$areakana3\n";

}

close(R);
close(W);
print "Last Step...\n";

&shell("sort < all.2 > all.3");
&shell("uniq < all.3 > all.all");
open(W,">>all.all");
$date=&date("Y-m-d H:i");
print W "version\t$date\n";
close(W);

unlink("all.1");
unlink("all.2");
unlink("all.3");

sub convert {
	my($s)=@_;
	$s=&trnum($s);
	$s=~s/ノ/no/g;
	$s=~s/ケ/ga/g;
	$s=~s/ヶ/ga/g;
	$s=Jcode->new($s,'utf8')->euc;
	$s=Text::Kakasi::do_kakasi($s);
	$s=~tr/[a-z]/[A-Z]/;
	return $s;
}

sub kana {
	my($s)=@_;
	$s=~s/ヶ/ガ/g;
	$s=Jcode->new($s,'utf8')->euc;
	$s=Text::Kakasi::do_kakasi($s);
	$s=Jcode->new($s,'euc')->utf8;
	return $s;
}

sub shell {
	my($shell)=@_;
	my $buf;
	open(PIPE,"$shell|");
	foreach(<PIPE>) {
		chomp;
		$buf.=$_;
	}
	close(PIPE);
	$buf;
}


sub init_kakasi {
    Text::Kakasi::getopt_argv("-Ja","-Ha","-Ka", "-Ea");
}

sub init_kakasi_kana {
    Text::Kakasi::getopt_argv("-JK","-HK","-KK", "-EK");
}

sub close_kakasi {
    Text::Kakasi::close_kanwadict();
}

sub trnum {
	my($buf)=@_;
	$buf=~s/０/0/g;
	$buf=~s/１/1/g;
	$buf=~s/２/2/g;
	$buf=~s/３/3/g;
	$buf=~s/４/4/g;
	$buf=~s/５/5/g;
	$buf=~s/６/6/g;
	$buf=~s/７/7/g;
	$buf=~s/８/8/g;
	$buf=~s/９/9/g;
	$buf=~s/－/-/g;
	$buf=~s/ー/-/g;
	$buf=~s/～/-/g;
	$buf=~s/\~/-/g;
	$buf=~s/\^/-/g;
	$buf=~s/・/･/g;
	$buf;
}

sub date {
	my ($format, $tm, $gmtime) = @_;
	my %weekday;
	my %ampm;

	# yday:0-365 $isdst Summertime:1/not:0
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = 
		$gmtime ne '' && @_ > 2
			? ($tm+0 > 0 ? gmtime($tm) : gmtime(time))
			: ($tm+0 > 0 ? localtime($tm) : localtime(time));

	$year += 1900;
	my $hr12=$hour=>12 ? $hour-12:$hour;
	# year
	$format =~ s/Y/$year/ge;	# Y:4char ex)1999 or 2003

	# month
	$mon++;									# mon is 0 to 11 add 1
	$format =~ s/n/$mon/ge;					# n:1-12
	$mon = "0" . $mon if ($mon < 10);
	$format =~ s/m/$mon/ge;					# m:01-12

	# day
	$format =~ s/j/$mday/ge;				# j:1-31
	$mday = "0" . $mday if ($mday < 10);
	$format =~ s/d/$mday/ge;				# d:01-31

	# hour
	$hour = "0" . $hour if ($hour < 10);
	$format =~ s/H/$hour/ge;				# H:00-23

	# minutes
	$min = "0" . $min if ($min < 10);
	$format =~ s/i/$min/ge;					# i:00-59

	# second
	$sec = "0" . $sec if ($sec < 10);
	$format =~ s/s/$sec/ge;					# s:00-59

	return $format;
}
